signature GRAPH =
sig
  eqtype node = int
  type 'a context = node list * node * 'a * node list
  type 'a graph

  exception Node
  exception Edge

  val empty      : int -> 'a graph
  val &          : 'a context * 'a graph -> 'a graph
  val context    : node * 'a graph -> 'a context * 'a graph
  val matchany   : 'a graph -> 'a context * 'a graph
  val noNodes    : 'a graph -> int
  val gmap     : ('a -> 'b) -> 'a graph -> 'b graph

  val ufold      : ('a context * 'b -> 'b) -> 'b -> 'a graph -> 'b
  val gfold      : ((node * int) list * node * 'a * (node * int) list -> 
                    (node * int) list) -> 
                   ('a * 'b -> 'c) -> ('c * 'b -> 'b) -> 'b -> 
                   node list -> 'a graph -> 'b
  val mfold      : ('a * 'b -> 'c) -> ('c * 'b -> 'b) -> 'b -> 
                   node list -> 'a graph -> 'b

  (* some functions for convenient input/output *)
  val el2gr    : 'a -> (node * node) list -> 'a graph
  val mkgr     : 'a list -> (node * node) list -> 'a graph
end
;
